<?php
/**
 * To jest tylko przykład wykorzystania klasy, by pokazac mniej więcej jak jej używać.
 * Logowanie co tu jest pokazane było tylko na moje proste testowe potrzeby, wiec i jest
 * najbanalniejsze na swiecie. Każdy niech se uzywa swojego (jak ja to robie w normalnym  projekcie), albo niech
 * usunie wogóle :)
 */
session_start();
require_once('cfg.inc.php');
require_once('libs/ShoutBox.class.php');
require_once('libs/ShoutBoxDBMysql.class.php');
if ($cfg_shoutbox['db_driver'] == 'ShoutBoxDBTxt') //jesli ustawimy sterownik na plikach to go ladujemy
	require_once('libs/ShoutBoxDBTxt.class.php');
require_once('libs/ShoutBoxDefaultFormatter.class.php');
require_once('libs/ShoutBoxDefaultRights.class.php');

error_reporting(E_ALL);
set_error_handler('errorHandler');
date_default_timezone_set('Europe/Warsaw');

if (empty($_SESSION['nick']) && !$cfg_shoutbox['guest_read']) //jeśli to gość i ustawimy w konfigu że nie może czytać, to go wywalamy
	exit;

if (!empty($_SESSION['nick'])){
	$nick = $_SESSION['nick'];
	$id = $_SESSION['id'];
} else {
	$nick = empty($_POST['nick']) ? null : htmlspecialchars($_POST['nick'], ENT_QUOTES);
	$id = null;
}

	
try {
	if ($cfg_shoutbox['db_driver'] == 'ShoutBoxDBMysql'){ //sterownik na mysql
		$dbd = new ShoutBoxDBMysql(null, $cfg_shoutbox['table_name']);
		//określenie tabeli z uzytkownikami w celu pobrania z niej coloru uzytkwnika
		$dbd->SetExtraUser('ShoutBoxUser', 'ID', array('COLOR'=>'COLOR'));
	} elseif ($cfg_shoutbox['db_driver'] == 'ShoutBoxDBTxt'){ //sterownik na plikach
		$dbd = new ShoutBoxDBTxt('shoutbox.txt');
		//$dbd->Color = skadspobieranykolor; - gdy macie np. w sesji zapamietany kolor usera to mozecie go wstawic to bedziecie mieli kolorowo
	}
	
	//tworzymy obiekt shoutboxa. Pliki pomocnicze będzie zakładał w katalogu temp naszej aplikacji
	$formatter = new ShoutBoxDefaultFormatter();
//	$formatter->EmoticonsUrl = 'http://jakis/inny/url/do/emoticon';
	$sb = new ShoutBox($formatter,$dbd,'./temp/', $nick, $id);
	if ($cfg_shoutbox['gzip'])
		$sb->gzip = true;
	if ($cfg_shoutbox['save_transfer'])
		$sb->saveTransfer = true;
	if ($cfg_shoutbox['period_removing']) //ustawiamy czasowe czyszczenie starych wiadomości
		$sb->SetPeriodRemoving($cfg_shoutbox['period_removing']['period'], $cfg_shoutbox['period_removing']['days'], $cfg_shoutbox['period_removing']['log_size']);
	
	//określenie dozwolonych komand
	$sb->commands = array('help','nick', 'me','color','ip');
	//określenie sciezki do klas z komendami. domyslnie to bedzie './libs/commands/'
	//$sb->commandsPath = 'nasza/inna/sciezka/do/klas/z/komendami/'
	
	//gdy jest to pierwsze wywołanie shouta dla danego usera
	if ($sb->IsFirstCall()) //zerujemy licznik historii
		$_SESSION['history'] = 0;
		
	//ustawiamy obiekt obsługi praw	
	$rightObject = new ShoutBoxDefaultRights($id, $nick);
	$sb->SetRightsObject($rightObject);
	
	//odpalamy shouta
	$sb->RunAction();
	
	//dodanie komunikatów dla osob floodujacych
	if ($sb->userMode & ShoutBox::F_LOCKED)
		$sb->AddAdminMessage('Zostałeś zablokowany za floodowanie.');
	elseif ($sb->userMode & ShoutBox::F_WARNED)
		$sb->AddAdminMessage('Nie floodować mi tu!!!');
		
	//teraz będziemy określac aktywnosc usera. Potrzebne to bedzie np. do wyswietlania osób online	
	$now = time();	
	if ($cfg_shoutbox['user_activity'] && !empty($_SESSION['id']) && (empty($_SESSION['last_active_time']) || $_SESSION['last_active_time'] < $now - $cfg_shoutbox['user_activity'])) {
	//co x sekund zapisujmy aktywnosc usera	
		$sql = 'update ShoutBoxUser set LAST_ACTIVE_TIME=now() where ID='.$_SESSION['id'];
		ShoutBoxDBMysql::MysqlConnect();
		$res = mysql_query($sql);
		if ($res !== false)
			$_SESSION['last_active_time'] = $now;
	}
	
	//dodanie komunikatu, że dany user właśnie się zalogował
	if (!empty($_SESSION['justlogged'])){ 
		$_SESSION['justlogged'] = false;
		if ($rightObject->IsBanned() === false)
			$sb->AddAdminMessage('<u>'.$_SESSION['nick'].'</u> dołączył', true);		
	}
	
	//dodanie komunikatu, że dany user właśnie się wylogował
	if (!empty($_SESSION['justloggout'])){ 
		if ($rightObject->IsBanned() === false)
			$sb->AddAdminMessage('<u>'.$_SESSION['justloggout'].'</u> wylogował się', true);		
		$_SESSION['justloggout'] = false;
	}
	
	//wygenerowanie pliku xml z odpowiedzią shouta dla przeglądarki
	echo $sb->Generate(true);
	
	//odpalać tylko dla sterownika Mysql. Sterownik txt nie ma pola Error
	//jesli byl jakiś błąd to go zgłosimy dla naszego prymitywnego loggera errorHandler
	if ($cfg_shoutbox['db_driver'] == 'ShoutBoxDBMysql' && $dbd->Error)
		trigger_error($dbd->Error);
}
catch (ShoutBoxException $ex){
	//i tu se cos z wyjatkiem róbcie, jago dla testow wywalam do triggera by mi sie w logach zapisalo :)
	trigger_error($ex->getMessage());
}

//Prosty handler do logowania błędów
function errorHandler($errNo, $errStr, $errFile, $errLine){
	$_msg = "Czas: ".date('Y-m-d H:i:s')." \n Plik: $errFile \n Linia: $errLine \n $errStr \n";
	$log = fopen('temp/ShoutBox.log', 'a');
	fwrite($log, $_msg);
	fclose($log);
	return true;
}
?>