<?php
/**
 * Domyślny formatter
 * 
 * @package MCM
 * @subpackage independent
 * @author Robert (nospor) Nodzewski (email: nospor at gmail dot com)
 * @copyright 2006-2008 Robert Nodzewski
 * @version 1.2
 * @access public
 */
class ShoutBoxDefaultFormatter implements ShoutBoxFormatter {
	private $_today;
	private $_sbObj = null;
	public $EmoticonsUrl = 'images/emoticons/';
	public function SetShoutBoxObject(&$sbObj){
		$this->_sbObj = $sbObj;
	}
	
	function __construct(){
		$this->_today = date('Y-m-d');
	}

	public function HtmlMessage($message){
		$owner=!empty($message['ADMIN']) ? '_a' : ((empty($message['ID_USER']) && empty($message['NICK'])) ? '_s' : (!empty($message['ID_USER']) && $message['ID_USER'] == $this->_sbObj->GetIdUser() ? '_o' : ''));
		$this->GettingMessageFormat($message);
		$id = $this->_sbObj->GetId();
		return '<div id="'.$id.'_m'.$message['ID'].'" class="sb_m'.$owner.'">'.
					($message['CAN_DELETE'] ? '<div class="sb_d" onclick="'.$id.'.dm('.$message['ID'].');"/>' : '').
					'<span class="sb_t">'.$message['TIME'].'</span>'.
					'<span class="sb_n"'.(!empty($message['COLOR']) ? ' style="color:#'.$message['COLOR'].'"' : '').'>'.$message['NICK'].'</span>'.
					'<div class="sb_tt'.($message['CAN_EDIT'] ? ' sb_e' : '').'"'.($message['CAN_EDIT'] ? ' title="Kliknij, by edytować" onclick="'.$id.'.tti('.$message['ID'].');"' : '').'>'.
						'<span>&nbsp;'.$message['MESSAGE'].'&nbsp;</span>'.
					'</div>'.
				'</div>';
	}
	
	public function HtmlMessageEdit($message){
		$owner=!empty($message['ADMIN']) ? '_a' : ((empty($message['ID_USER']) && empty($message['NICK'])) ? '_s' : (!empty($message['ID_USER']) && $message['ID_USER'] == $this->_sbObj->GetIdUser() ? '_o' : ''));
		$this->GettingMessageFormat($message);
		$message['MESSAGE'] = $this->ReformatMessage($message['MESSAGE']);
		$id = $this->_sbObj->GetId();
		return '<div id="'.$id.'_m'.$message['ID'].'" class="sb_m'.$owner.'">'.
					($message['CAN_DELETE'] ? '<div class="sb_d" onclick="'.$id.'.dm('.$message['ID'].');"/>' : '').
					'<span class="sb_t">'.$message['TIME'].'</span>'.
					'<span class="sb_n"'.(!empty($message['COLOR']) ? ' style="color:#'.$message['COLOR'].'"' : '').'>'.$message['NICK'].'</span>'.
					'<div class="sb_tt'.($message['CAN_EDIT'] ? ' sb_e' : '').'">'.
						'<input type="text" class="sb_input_text" value="'.htmlspecialchars($message['MESSAGE']).'" onkeypress="if (ShoutBox.isEnter(event)) '.$id.'.inputToText('.$message['ID'].',this);" onblur="'.$id.'.inputToText('.$message['ID'].',this);"/>'.
					'</div>'.
				'</div><script type="text/javascript">setTimeout(\'jQuery("#'.$id.'_m'.$message['ID'].' input").css("width",jQuery("#'.$id.'_m'.$message['ID'].' .sb_tt").width()-10).focus()\',100);</script>';
	}
	
	
	public function GettingMessageFormat(&$message){
		$d = date('Y-m-d', $message['TIME']); 
		$message['TIME'] = '['.($d == $this->_today ? 'dziś ' : ($d.' ')).date('H:i', $message['TIME']).']';
		if (empty($message['ADMIN']) && empty($message['ID_USER']) && !empty($message['NICK'])) //gdy pisał gość, to dodajemy przedrostek, by żaden gość nie mógł się podszyć poz zalogowanego usera
			$message['NICK'] = 'gość_'.$message['NICK'];
		$message['NICK'].= ':';
	}
	
	private function getEmoticons(){
		if (file_exists('images/emoticons/emoticons.txt.cache')){
			$ar = unserialize(file_get_contents('images/emoticons/emoticons.txt.cache'));
			if ($ar)
				return $ar;
		}
		
		if (!file_exists('images/emoticons/emoticons.txt'))
			return false;
		$handle = fopen('images/emoticons/emoticons.txt', 'r');
		if (!$handle)
			return false;
		$ar = array();
		while (!feof($handle)) {
			$line = trim(fgets($handle));
			$_ar = preg_split('/#+/', $line);
			if (!$_ar || count($_ar) < 2)
				continue;
			$em = trim($_ar[0]);	
			$im = trim($_ar[1]);
			$ar[$em] = '<img src="'.$this->EmoticonsUrl.$im.'" />';	
		}
		fclose($handle);
		file_put_contents('images/emoticons/emoticons.txt.cache', serialize($ar));		
		return $ar;	
	}
	
	public function AddingMessageFormat($message){
		if (strlen($message)> 255)
			$message = substr($message,0,255);
		$message = nl2br(htmlspecialchars(trim($message), ENT_QUOTES));
		$search = array (
			'#\[b\](.*?)\[/b\]#si',
			'#\[i\](.*?)\[/i\]#si',
			'#\[u\](.*?)\[/u\]#si',
			'#&lt;\s*a.*?&gt;(.*?)&lt;\s*/\s*a\s*&gt;#si',
			'#([^/]|^)(www\..*?\..*?)(\s|$)#si',
			'#([^">]|^)(http://.*?\..*?)(\s|$)#si'
		);
		$replace = array(
			'<b>\\1</b>',
			'<i>\\1</i>',
			'<u>\\1</u>',
			'\\1',
			'\\1<a href="http://\\2">\\2</a>\\3',
			'\\1<a href="\\2">\\2</a>\\3'
		);
		
		$message = preg_replace($search, $replace, $message);

		$search = array (
			'\\'
		);
		$replace = array(
			'&#92;'
		);
		$message = str_ireplace($search, $replace, $message);
		
		$emoticons = $this->getEmoticons();
		if ($emoticons)
			$message = str_replace(array_keys($emoticons), array_values($emoticons), $message);
		
		//prosty cenzor - jeśli go nie chcecie to zakomentujcie linie poniżej
		$message = $this->censor($message);	
			
		return $message;
	}
	
	private function censor($text){
			/* ALL RIGHTS RESERVED */
			/* by www.majdan.eu */
			$przeklenstwa = array('bit(h|ch)', '(ch|h)(w|.w)(d|.d)(p|.p)', '(|o)cip', '(|o)(ch|h)uj(|a)', '(|do|na|po|do|prze|przy|roz|u|w|wy|za|z|matkojeb)jeb(|a|c|i|n|y)', '(|do|od|o|s|wy|za)pieprz(|e|n|on|a|y)', '(|do|na|naw|od|pod|po|prze|przy|roz|spie|roz|poroz|s|u|w|za|wy)pierd(a|o)', 'fu(ck|k)', '(|u)dup', '(|po|s|w|za)(ku|q)rw(i|y)', 'k(ó|u)rw', 'k(ó|u)tas', '(|po|wy)rucha', 'motherfucker', 'piczk', '(|w)pi(z|ź)d');
	 
			foreach($przeklenstwa As $i => $v ) {
					$przeklenstwa[$i] = '@[ \.]'.$v.'([^ ]+)?@i ';
			} 
			return preg_replace( $przeklenstwa, '<i>#cenzura#</i>', ' '.$text );
	} 
	
	public function ReformatMessage($message){
		$search = array (
			'#\<b\>(.*?)\</b\>#si',
			'#\<i\>(.*?)\</i\>#si',
			'#\<u\>(.*?)\</u\>#si',
			'#\<a href="http://.*?"\>(.*?)\</a\>#si',
		);
		$replace = array(
			'[b]\\1[/b]',
			'[i]\\1[/i]',
			'[u]\\1[/u]',
			'\\1'
		);
		
		$message = preg_replace($search, $replace, $message);

		$replace = array (
			'\\'
		);
		$search = array(
			'&#92;'
		);
		
		$message = str_replace($search, $replace, $message);
		$emoticons = $this->getEmoticons();
		if ($emoticons)
			$message = str_replace(array_values($emoticons), array_keys($emoticons), $message);
		$message = html_entity_decode($message, ENT_QUOTES);
		return $message;
	}

	public function GetUsersOnLine($refresh, $reset = false){
		if ($reset || !file_exists('temp/online.txt') || filemtime('temp/online.txt') < time() - 120){
		//jesli plik nie istnieje lub ostatnio byl aktualizowany 2 minuty temu, to go odswierz
			$sql = 'select NICK, COLOR from ShoutBoxUser where DATE_SUB(NOW(),INTERVAL 40 SECOND) <= LAST_ACTIVE_TIME order by NICK';//pobierz userow aktywnych w ciagu ostatnich 40 sekund
			ShoutBoxDBMysql::MysqlConnect();
			$res = mysql_query($sql);
			if ($res){
				$online = array();
				while ($row=mysql_fetch_array($res)){
//					$online[$row['NICK']] = array('style'=>'color:#'.$row['COLOR'].';');
					$online[$row['NICK']] = '<li'.(!empty($row['COLOR']) ? ' style="color: #'.$row['COLOR'].';"' : '').'>'.$row['NICK'].'</li>';
				}
				file_put_contents('temp/online.txt', serialize($online));
				return $online;
			}
		} elseif ($refresh || filemtime('temp/online.txt') > time() - 20) { //jesli plik zmienil sie w ciagu ostatnich 20 sekund, to wczytaj jego zawartosc
			$online = unserialize(file_get_contents('temp/online.txt'));
			if (is_array($online))
				return $online;
			return null;
		}	
		return null; // nic sie nie zmienilo, nie ma co odswierzac
	}
}
?>