<?php
/**
 * Komenda help
 * Słuzy do wyswietlenia pomocy
 * Wywolanie: /help
 * 
 * @package MCM
 * @subpackage independent
 * @author Robert (nospor) Nodzewski (email: nospor at gmail dot com)
 * @copyright 2006-2008 Robert Nodzewski
 * @access public
 */
class ShoutBoxCommandHelp implements ShoutBoxCommand {
	public function Run($arg, ShoutBox $sbObject, ShoutBoxDB $dbObject, ShoutBoxFormatter $formatterObject, ShoutBoxRights $rightsObject){
		if ($arg == 'ip'){
			$sbObject->AddAdminMessage('<b>Zarządzanie IP</b><br />
			<b>/ip show</b> <i>nick</i> - dla podanego <i>nick</i> wyświetla IP z jakich pisał<br />
			<b>/ip shownick</b> <i>IP</i> - dla podanego <i>IP</i> wyświetla nicki, jakie pisały z tego IP<br />
			<b>/ip ban</b> <i>IP</i> <i>tekst</i> - banuje podane <i>IP</i>. Jeśli podamy <i>tekst</i>, będzie on wyświetlany zamiast komunikatu o banie, np:<br />
			<i>/ip ban 192.168.10.10 Hej, zbanowałem Cię bo tak</i> - spowoduje zbanowanie adresu IP 192.168.10.10 i każda próba dostępu do ShoutBoxa z tego adresu spowoduje wyświetlenie podanego tekstu<br />
			<b>/ip unban</b> <i>IP</i> - zdejmuje bana dla danego <i>IP</i><br />
			<b>/ip showbanned</b> - wyświetla listę zbanowanych IP<br /><br />
			<b>UWAGA:</b><br />
			Wszędzie tam, gdzie należy podać IP, można podać IP w całości, np: <br />165.12.12.11, 12.12.11.187 itp.<br /> lub ogólnie, np:<br />123.45.*, 12.*, 192.168.10.* itp.');
			return true;
		}
		
		$sbObject->AddAdminMessage('<u>Dostępne komendy:</u><br /><b>/help</b> - pomoc<br />
		<b>/nick</b> <i>nowynick</i> - zmiana nicka na <i>nowynick</i><br />
		<b>/me</b> <i>tekst</i> - wszyscy zobaczą zobaczą Twoj nick a obok tekst co podałeś<br />
		<b>/color</b> <i>XXXXXX</i> - zmiana koloru (X to cyfry 0-9 lub litery a-f)<br />
		<b>/ip</b> - zarządzanie IP. Wpisz <i>/help ip</i> by dowiedzieć się więcej <br />
		<u>Dostępne emotikony:</u> :) :( :lol: :P<br />
		<u>Dostępne bbcode:</u> [b] [u] [i] oraz linki<br />
		<u>Bajery:</u><br />
		<b>tabulator</b> - wpisz część czyjegoś nicka, kto jest online, i wciśnij tabulator<br />
		(można też nie wpisywać nicka, będziemy wówczas skakać po wszystkich użytkownikach online)');
		
		return true;
	}
}
?>